#
# spec file for package perl-MooseX-Role-Parameterized
#
# Copyright (c) 2019 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


Name:           perl-MooseX-Role-Parameterized
Version:        1.11
Release:        1.22
#Upstream: Artistic-1.0 or GPL-1.0-or-later
%define cpan_name MooseX-Role-Parameterized
Summary:        Moose roles with composition parameters
License:        Artistic-1.0 OR GPL-1.0-or-later
Group:          Development/Libraries/Perl
Url:            https://metacpan.org/release/%{cpan_name}
Source0:        https://cpan.metacpan.org/authors/id/E/ET/ETHER/%{cpan_name}-%{version}.tar.gz
Source1:        cpanspec.yml
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  perl
BuildRequires:  perl-macros
BuildRequires:  perl(CPAN::Meta::Check) >= 0.011
BuildRequires:  perl(CPAN::Meta::Requirements)
BuildRequires:  perl(Module::Build::Tiny) >= 0.034
BuildRequires:  perl(Module::Metadata)
BuildRequires:  perl(Module::Runtime)
BuildRequires:  perl(Moose) >= 2.0300
BuildRequires:  perl(Moose::Exporter)
BuildRequires:  perl(Moose::Meta::Role)
BuildRequires:  perl(Moose::Role)
BuildRequires:  perl(Moose::Util)
BuildRequires:  perl(Moose::Util::TypeConstraints)
BuildRequires:  perl(Test::Fatal)
BuildRequires:  perl(Test::Moose)
BuildRequires:  perl(Test::More) >= 0.96
BuildRequires:  perl(Test::Needs)
BuildRequires:  perl(namespace::autoclean)
BuildRequires:  perl(namespace::clean) >= 0.19
Requires:       perl(Module::Runtime)
Requires:       perl(Moose) >= 2.0300
Requires:       perl(Moose::Exporter)
Requires:       perl(Moose::Meta::Role)
Requires:       perl(Moose::Role)
Requires:       perl(Moose::Util)
Requires:       perl(namespace::autoclean)
Requires:       perl(namespace::clean) >= 0.19
%{perl_requires}

%description
Your parameterized role consists of two new things: parameter declarations
and a 'role' block.

Parameters are declared using the parameter keyword which very much
resembles Moose/has. You can use any option that Moose/has accepts. The
default value for the 'is' option is 'ro' as that's a very common case. Use
'is => 'bare'' if you want no accessor. These parameters will get their
values when the consuming class (or role) uses Moose/with. A parameter
object will be constructed with these values, and passed to the 'role'
block.

The 'role' block then uses the usual Moose::Role keywords to build up a
role. You can shift off the parameter object to inspect what the consuming
class provided as parameters. You use the parameters to customize your role
however you wish.

There are many possible implementations for parameterized roles (hopefully
with a consistent enough API); I believe this to be the easiest and most
flexible design. Coincidentally, Pugs originally had an eerily similar
design.

See MooseX::Role::Parameterized::Extending for some tips on how to extend
this module.

%prep
%setup -q -n %{cpan_name}-%{version}

%build
perl Build.PL --installdirs=vendor
./Build build --flags=%{?_smp_mflags}

%check
./Build test

%install
./Build install --destdir=%{buildroot} --create_packlist=0
%perl_gen_filelist

%files -f %{name}.files
%defattr(-,root,root,755)
%doc Changes CONTRIBUTING README
%license LICENSE

%changelog
* Tue Jul 16 2019 Stephan Kulow <coolo@suse.com>
- updated to 1.11
  see /usr/share/doc/packages/perl-MooseX-Role-Parameterized/Changes
  1.11      2019-07-16 01:33:16Z
  - remove MooseX::Role::WithOverloading from test dependencies (RT#130075)
* Fri Apr 21 2017 coolo@suse.com
- updated to 1.10
  see /usr/share/doc/packages/perl-MooseX-Role-Parameterized/Changes
  1.10      2017-04-20 17:50:53Z
  - add MooseX::Role::Parameterised as stub documentation, for
    discoverability
* Sun Aug  7 2016 coolo@suse.com
- updated to 1.09
  see /usr/share/doc/packages/perl-MooseX-Role-Parameterized/Changes
  1.09      2016-08-07 01:20:31Z
  - Give 'anonymous' generated roles names that are similar to the original
    parameterized role so debug output is easier to read
* Tue Apr 14 2015 coolo@suse.com
- updated to 1.08
  see /usr/share/doc/packages/perl-MooseX-Role-Parameterized/Changes
* Fri Oct  4 2013 coolo@suse.com
- updated to 1.02
  * set %%INC entries in test to avoid failures with
    Moose pre-2.11 (kentfrederic)
    https://github.com/sartak/MooseX-Role-Parameterized/pull/7
    https://rt.cpan.org/Ticket/Display.html?id=88593
  * removed use of deprecated Class::MOP::load_class (ether)
- remove outdated patch perl-MooseX-Role-Parameterized-old_Test_More.patch
* Mon Feb 27 2012 coolo@suse.com
- updated to 1.00
  * MooseX::Role::Parameterized now depends on Moose 2.0300
    released 2011-09-23 for its several core improvements, hence the
    major version number bump.
  * MXRP now uses the new meta_lookup feature added to Moose 2.0300
    (specifically for MXRP) to avoid duplicating Moose-0.60-era
    Moose::Role sugar. This means the error messages you get are
    better, and there's a lot less ugly code in MXRP.
  * Remove alias/excludes special case errors. They have long since been
    replaced in core Moose by -alias and -excludes, and were finally
    removed in Moose 2.0200.
  * Expressly forbid using role { } inside role { } (which makes no
    sense but I suppose you could accidentally trigger it)
  * Documentation fix from cweyl@alumni.drew.edu
    https://github.com/sartak/MooseX-Role-Parameterized/pull/5
* Mon Dec 19 2011 coolo@suse.de
- update to 0.27
  * Remove MooseX::Role::Parameterized::Meta::Parameter; instead,
    the default for parameters of (is => 'ro') is set by the
    "parameter" sugar. This removes an unnecessary metaclass and
    removes weird edge cases caused by it. Please please please
    report any breakage!
* Sat Jun  4 2011 lars@linux-schulserver.de
- fix build on distributions with old Test::More module
  ( perl-MooseX-Role-Parameterized-old_Test_More.patch )
* Sun May  1 2011 coolo@opensuse.org
- updated to 0.26
  * make tests stop relying on a specific format for anon class/role names (doy)
  * Move the reinitialization hook from Role to Trait so hardcore hackers
    (trait janitors) get the benefit too (doy)
  * Made MXRP more extensible by hooking into the role metaobject
    reinitialization (doy)
  * Merry Christmas!
  * Make MooseX::Role::Parameterized::Extending more instructive. Hopefully.
  * The test suite now uses Test::Fatal instead of Test::Exception (Karen
    Etheridge).
  * Fix Test::More dependency (reported by Father Chrysostomos) [rt.cpan.org #63222]
  * "package" arg can now tell generate_role to use a specific package (rjbs)
  * Minor test refactoring to fix blead support [rt.perl.org #78244]
* Wed Dec  1 2010 coolo@novell.com
- switch to perl_requires macro
* Mon Nov 29 2010 coolo@novell.com
- remove /var/adm/perl-modules
* Mon Jul 26 2010 pascal.bleser@opensuse.org
- initial package (0.19)
